<template>
    <app-layout>
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <h1 class="h2 mb-3">Manage {{ manangeUser.username }}</h1>
                
                <form @submit.prevent="form.patch(route('users.update', manangeUser))">
                    <form-field text="Username" id="inputUsername" :errors="form.errors.username" v-slot="slotProps">
                        <form-input v-model="form.username" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Password" id="inputPassword" :errors="form.errors.password" v-slot="slotProps">
                        <form-input v-model="form.password" v-bind="slotProps" />
                    </form-field>
                    
                    <form-checkbox-field text="Permissions">
                        <form-checkbox :disabled="isSelf" id="inputPermUsers" v-model="form.manage_users">Manage panel users</form-checkbox>
                    </form-checkbox-field>
                    
                    <form-button :disabled="form.processing">Save Changes</form-button>
                    <inertia-link :disabled="isSelf" class="btn btn-danger ms-2" as="button" type="button" :href="route('users.delete', manangeUser)" method="delete">Delete User</inertia-link>
                </form>
            </div>
        </div>
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import FormInput from '@/Components/Form/FormInput'
    import FormField from '@/Components/Form/FormField'
    import FormButton from '@/Components/Form/FormButton'
    import FormCheckboxField from '@/Components/Form/FormCheckboxField'
    import FormCheckbox from '@/Components/Form/FormCheckbox'
    
    export default {
        props: {
            'manangeUser': Object,
            'isSelf': Boolean,
        },
        
        components: {
            AppLayout,
            FormInput,
            FormField,
            FormButton,
            FormCheckboxField,
            FormCheckbox,
        },
        
        mounted() {
            this.form.username = this.manangeUser.username
            this.form.manage_users = this.manangeUser.manage_users
        },
        
        setup () {
            const form = useForm({
                username: null,
                password: null,
                manage_users: false,
            })

            return { form }
        },
    }
</script>